#!/usr/bin/perl
push @INC, '.';
use PerlHP;

<%
	# mod of manfire.cgi by J. Manfire
	#
	# ported to PerlHP by !WAHa.06x36
        #
        # slight modifications by Talysman the Ur-Beatle
        # Updated to be a simple image gallery. Assumes script is in a directory with
        # with pictures labeled *_story.jpg and *_story_thumb.jpg. There may be other
        # images in directory, which will be ignored by this script. Also in the same
        # directory are text files labeled *_story.txt, which contain the description
        # for each image.
        #
        # File names must not contain underscores other than the one before _story or
        # _thumb. Extra underscores skips either the comments or the image, whichever
        # one has the exta character.
        #
        # PerlHP.pm must be either in the same directory, or in a directory along the
        # search path.
        #
        # Optionally, this script can be in the main directory and symbolic links can
        # be made in each image folder.

        # image stuff, mostly as originally written by Dag/Manfire

	$file=escape_html($file);
	my @allfiles=grep { !/.*_thumb\..*/ } glob("*_story.jpg"); # only the covers
	my $bigimage=($file or $allfiles[0]);
        my @noextimage=split(/_.*\.jpg/,$bigimage);                # the front part of filename
	my $inlineimage=$noextimage[0] . "_story_thumb.jpg";
	$inlineimage=$bigimage unless -e $inlineimage;

	open IMAGE,$inlineimage;
	my ($width,$height)=analyze_jpeg(\*IMAGE);
	close IMAGE;

	my $index=GETINDEX();
	my $previmage=$index!=0?$allfiles[$index-1]:undef;
	my $nextimage=$index!=$#allfiles?$allfiles[$index+1]:undef;

	sub GETINDEX
	{
		foreach my $index ( 0 .. $#allfiles ) { return $index if $allfiles[$index] eq $bigimage; }
		return undef;
	}

        # find stories/captions/notes, too

	my $linernotes=$noextimage[0] . "_story.txt";                 # name starts same as cover image
        my $story="";
        if (-e $linernotes) {
	    open NOTES,$linernotes;
            while (<NOTES>) {
		$story=$_;	    }
	    close NOTES;
} else { $story = "No comments on $linernotes."; }

%>

<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<title><% print "$noextimage album" %></title>
<style type="text/css">
form { margin: 0px; }
#all { display: table; }
#display a { color: #000; }
#display a:hover { color: #f83; }
#display img { border-width: 1px; }
.navi { width: 100%; display: table; text-align: right;  border: 1px solid #000; margin: 0.5em 0em; }
.prevnext { float:left; padding: 6px; }
.filelist { float:right; padding: 2px; }
.filelist input { background: #fff; border: 1px solid #000;  }
.filelist input:hover { background: #000; color: #fff; border: 1px solid #000;  }
.prevnext a { color: #d62; padding: 4px; text-decoration: none; }
.prevnext a:hover { background: #fec; padding: 3px; border: 1px solid #d62; -moz-border-radius: 4px; }
</style>
</head>

<body>
<div id="all">

  <div id="topnavi" class="navi"><% PRINTNAVI() %></div>

  <div id="display">
    <div class="story">
      <p>
<%

print $story;
%>
      </p>
      <hr>
    </div>
  <a href="<% print $bigimage %>">
    <img width="<% print $width %>" height="<% print $height %>" src="<% print $inlineimage %>" />
  </a>
  <p>Click images to enlarge.</p>
<% unless($nextimage) { %>
	<p>The story tour ends here, but you can <a href="<% print "$ENV{SCRIPT_NAME}?file=$allfiles[0]" %>">go back to the beginning</a>.
<% } %>
  </div>

  <div id="bottomnavi" class="navi"><% PRINTNAVI() %></div>
</div>
</body></html>

<% sub PRINTNAVI() { %>
	<div class="prevnext">
	<% if($previmage) { print "<a href=\"$ENV{SCRIPT_NAME}?file=$previmage\">&lt; Previous</a>" } else { print "&lt; Previous" } %>
	<% if($nextimage) { print "<a href=\"$ENV{SCRIPT_NAME}?file=$nextimage\">Next &gt;</a>" } else { print "Next &gt;" } %>
	</div>
	<div class="filelist"><form method="get" action="<% print $ENV{SCRIPT_NAME} %>">
	<select name="file"><% for(@allfiles) {
		if($_ eq $file) { print "<option selected=\"selected\" value=\"$_\">$_</option>" }
		else { print "<option value=\"$_\">$_</option>" }
	} %></select>
	<input type="submit" value="Go" />
	</form></div>
<% } %>

<%

sub analyze_jpeg($)
{
	my ($file)=@_;
	my ($buffer);

	read($file,$buffer,2);

	if($buffer eq "\xff\xd8")
	{
		OUTER:
		for(;;)
		{
			for(;;)
			{
				last OUTER unless(read($file,$buffer,1));
				last if($buffer eq "\xff");
			}

			last unless(read($file,$buffer,3)==3);
			my ($mark,$size)=unpack("Cn",$buffer);
			last if($mark==0xda or $mark==0xd9);  # SOS/EOI
			die "Possible virus in image" if($size<2); # MS GDI+ JPEG exploit uses short chunks

			if($mark>=0xc0 and $mark<=0xc2) # SOF0..SOF2 - what the hell are the rest? 
			{
				last unless(read($file,$buffer,5)==5);
				my ($bits,$height,$width)=unpack("Cnn",$buffer);
				seek($file,0,0);

				return($width,$height);
			}

			seek($file,$size-2,1);
		}
	}

	seek($file,0,0);

	return ();
}

%>
</body></html>
